//+------------------------------------------------------------------+
//|                                           Henderson's filter.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  PaleVioletRed
#property indicator_color2  DeepSkyBlue
#property indicator_color3  DeepSkyBlue
#property indicator_color4  PaleVioletRed
#property indicator_color5  DeepSkyBlue
#property indicator_color6  DeepSkyBlue
#property indicator_color7  DeepSkyBlue
#property indicator_color8  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_width7  1
#property indicator_width8  1

//
//
//
//
//

extern string TimeFrame      = "Current time frame";
extern int    PriceFast      = PRICE_CLOSE;
extern int    PriceSlow      = PRICE_CLOSE;
extern int    FilterSizeFast = 13;
extern int    FilterSizeSlow = 50;
extern double GapForArrows   = 0.75;
extern bool   MultiColor     = true;
extern bool   TrendColors    = false;
extern bool   ArrowsVisible  = false;
extern bool   Interpolate    = false;

extern bool   alertsOn        = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double arrowUp[];
double arrowDn[];
double weightsf[];
double weightss[];
int halff,halfs;

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2); if (MultiColor)    SetIndexStyle(1,DRAW_LINE);  else SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(2,buffer3); if (MultiColor)    SetIndexStyle(2,DRAW_LINE);  else SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(3,buffer4);
   SetIndexBuffer(4,buffer5); if (MultiColor)    SetIndexStyle(4,DRAW_LINE);  else SetIndexStyle(4,DRAW_NONE);
   SetIndexBuffer(5,buffer6); if (MultiColor)    SetIndexStyle(5,DRAW_LINE);  else SetIndexStyle(5,DRAW_NONE);
   SetIndexBuffer(6,arrowUp); if (ArrowsVisible) SetIndexStyle(6,DRAW_ARROW); else SetIndexStyle(6,DRAW_NONE); SetIndexArrow(6,217);
   SetIndexBuffer(7,arrowDn); if (ArrowsVisible) SetIndexStyle(7,DRAW_ARROW); else SetIndexStyle(7,DRAW_NONE); SetIndexArrow(7,218);

      //
      //
      //
      //
      //
            
      FilterSizeFast = MathMax(FilterSizeFast,3);
            if (MathMod(FilterSizeFast,2)==0) FilterSizeFast++;
      halff = MathFloor(FilterSizeFast/2.0); 
      FilterSizeSlow = MathMax(FilterSizeSlow,3);
            if (MathMod(FilterSizeSlow,2)==0) FilterSizeSlow++;
      halfs = MathFloor(FilterSizeSlow/2.0); 

      //
      //
      //
      //
      //

         indicatorFileName = WindowExpertName();
         timeFrame         = stringToTimeFrame(TimeFrame);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars) return(0);
         calculateValue    = (TimeFrame=="calculateValue");
         if (calculateValue || timeFrame==Period())
         {
               ArrayResize(weightsf,FilterSizeFast);
               ArrayResize(weightss,FilterSizeSlow);
               
               //
               //
               //
               //
               //
               
               double m = halff;
               double divisor = 8.0*(m+2.0)*((m+2.0)*(m+2.0)-1.0)*(4.0*(m+2.0)*(m+2)-1.0)*(4.0*(m+2.0)*(m+2.0)-9.0)*(4.0*(m+2.0)*(m+2.0)-25.0);  
               for (int j=-halff; j<=halff; j++)
                  weightsf[j+halff] = 315.0*((m+1.0)*(m+1.0)-(j*j))*((m+2.0)*(m+2.0)-(j*j))*((m+3.0)*(m+3.0)-(j*j))*(3.0*(m+2.0)*(m+2.0)-11.0*(j*j)-16.0)/divisor;
                  
               //
               //
               //
               //
               //
                  
               m       = halfs;                  
               divisor = 8.0*(m+2.0)*((m+2.0)*(m+2.0)-1.0)*(4.0*(m+2.0)*(m+2)-1.0)*(4.0*(m+2.0)*(m+2.0)-9.0)*(4.0*(m+2.0)*(m+2.0)-25.0);  
               for (j=-halfs; j<=halfs; j++)
                  weightss[j+halfs] = 315.0*((m+1.0)*(m+1.0)-(j*j))*((m+2.0)*(m+2.0)-(j*j))*((m+3.0)*(m+3.0)-(j*j))*(3.0*(m+2.0)*(m+2.0)-11.0*(j*j)-16.0)/divisor;
         }
         if (calculateValue) return(0);
       
      //
      //
      //
      //
      //
     
   return(0);
}
int deinit() { return(0); }



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double trends[][3];
#define _slope1 0
#define _slope2 1
#define _trend  2

//
//
//
//
//

int start()
{
   int i,j,r,limit,counted_bars=IndicatorCounted();
   int sizef = ArraySize(weightsf);
   int sizes = ArraySize(weightss);

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(MathMax(Bars-counted_bars,MathMax(halff,halfs)),Bars-1);
         if (returnBars) { buffer1[0] = limit+1; return(0); }
         if (ArrayRange(trends,0)!= Bars) ArrayResize(trends,Bars);

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      if (TrendColors)
      {
         if (trends[Bars-limit-1][_trend]==1) ClearPoint(limit,buffer2,buffer3);
         if (trends[Bars-limit-1][_trend]==1) ClearPoint(limit,buffer5,buffer6);
      }
      else
      {
         if (trends[Bars-limit-1][_slope1]==1) ClearPoint(limit,buffer2,buffer3);
         if (trends[Bars-limit-1][_slope2]==1) ClearPoint(limit,buffer5,buffer6);
      }         
      
      //
      //
      //
      //
      //
      
      for(i=limit, r=Bars-i-1; i>=0; i--, r++)
      {
         double modf = 1.0;
         double mods = 1.0;
         if (i<halff)
         {
            double weightTotalf = 0; for (j=halff-i; j<sizef; j++) weightTotalf += weightsf[j]; if (weightTotalf!=0) modf = 1.0/weightTotalf;
         }
         if (i<halfs)
         {
            double weightTotals = 0; for (j=halfs-i; j<sizes; j++) weightTotals += weightss[j]; if (weightTotals!=0) mods = 1.0/weightTotals;
         }
         
         //
         //
         //
         // 
         //
               
         double sumf = modf*weightsf[halff]*iMA(NULL,0,1,0,MODE_SMA,PriceFast,i);
         for(j=1; j<=halff; j++)
         {
            if (j<=i) sumf += modf*weightsf[halff+j]*iMA(NULL,0,1,0,MODE_SMA,PriceFast,i-j);
                      sumf += modf*weightsf[halff-j]*iMA(NULL,0,1,0,MODE_SMA,PriceFast,i+j);
         }
         double sums = mods*weightss[halfs]*iMA(NULL,0,1,0,MODE_SMA,PriceSlow,i);
         for(j=1; j<=halfs; j++)
         {
            if (j<=i) sums += mods*weightss[halfs+j]*iMA(NULL,0,1,0,MODE_SMA,PriceSlow,i-j);
                      sums += mods*weightss[halfs-j]*iMA(NULL,0,1,0,MODE_SMA,PriceSlow,i+j);
         }
         
         //
         //
         //
         //
         //
         
         buffer1[i]         = sumf;
         buffer2[i]         = EMPTY_VALUE;
         buffer3[i]         = EMPTY_VALUE;
         buffer4[i]         = sums;
         buffer5[i]         = EMPTY_VALUE;
         buffer6[i]         = EMPTY_VALUE;
         arrowUp[i]         = EMPTY_VALUE;
         arrowDn[i]         = EMPTY_VALUE;
         trends[r][_slope1] = trends[r-1][_slope1];
         trends[r][_slope2] = trends[r-1][_slope2];
         trends[r][_trend]  = trends[r-1][_trend];
            if (buffer1[i] > buffer1[i+1]) trends[r][_slope1] =  1;
            if (buffer1[i] < buffer1[i+1]) trends[r][_slope1] = -1;
            if (buffer4[i] > buffer4[i+1]) trends[r][_slope2] =  1;
            if (buffer4[i] < buffer4[i+1]) trends[r][_slope2] = -1;
            if (buffer1[i] > buffer4[i]) trends[r][_trend] =  1;
            if (buffer1[i] < buffer4[i]) trends[r][_trend] = -1;
            if (trends[r][_trend]!=trends[r-1][_trend])
            {
               if (trends[r][_trend] ==  1) arrowUp[i] = MathMin(buffer1[i],buffer4[i]) - GapForArrows*iATR(NULL,0,20,i);
               if (trends[r][_trend] == -1) arrowDn[i] = MathMax(buffer1[i],buffer4[i]) + GapForArrows*iATR(NULL,0,20,i);
            }
            if (TrendColors)
            {
               if (trends[r][_trend] == 1) PlotPoint(i,buffer2,buffer3,buffer1);
               if (trends[r][_trend] == 1) PlotPoint(i,buffer5,buffer6,buffer4);
            }
            else
            {
               if (trends[r][_slope1] == 1) PlotPoint(i,buffer2,buffer3,buffer1);
               if (trends[r][_slope2] == 1) PlotPoint(i,buffer5,buffer6,buffer4);
            }
      }            
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (trends[Bars-limit-1][_slope1]==1) ClearPoint(limit,buffer2,buffer3);
   if (trends[Bars-limit-1][_slope2]==1) ClearPoint(limit,buffer5,buffer6);
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         buffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceFast,PriceSlow,FilterSizeFast,FilterSizeSlow,0,y);
         buffer4[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",PriceFast,PriceSlow,FilterSizeFast,FilterSizeSlow,3,y);
         buffer2[i] = EMPTY_VALUE;
         buffer3[i] = EMPTY_VALUE;
         buffer5[i] = EMPTY_VALUE;
         buffer6[i] = EMPTY_VALUE;
         arrowUp[i] = EMPTY_VALUE;
         arrowDn[i] = EMPTY_VALUE;
         
         //
         //
         //
         //
         //
         
            trends[r][_slope1] = trends[r-1][_slope1];
            trends[r][_slope2] = trends[r-1][_slope2];
            trends[r][_trend]  = trends[r-1][_trend];
               if (buffer1[i] > buffer1[i+1]) trends[r][_slope1] =  1;
               if (buffer1[i] < buffer1[i+1]) trends[r][_slope1] = -1;
               if (buffer4[i] > buffer4[i+1]) trends[r][_slope2] =  1;
               if (buffer4[i] < buffer4[i+1]) trends[r][_slope2] = -1;
               if (buffer1[i] > buffer4[i])   trends[r][_trend]  =  1;
               if (buffer1[i] < buffer4[i])   trends[r][_trend]  = -1;
               if (trends[r][_trend]!=trends[r-1][_trend])
               {
                  if (trends[r][_trend] ==  1) arrowUp[i] = MathMin(buffer1[i],buffer4[i])-GapForArrows*iATR(NULL,0,20,i);
                  if (trends[r][_trend] == -1) arrowDn[i] = MathMax(buffer1[i],buffer4[i])+GapForArrows*iATR(NULL,0,20,i);
               }
            
         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               buffer1[i+k] = buffer1[i] + (buffer1[i+n]-buffer1[i])*k/n;
               buffer4[i+k] = buffer4[i] + (buffer4[i+n]-buffer4[i])*k/n;
            }               
   }
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      if (TrendColors)
      {
         if (trends[r][_trend] == 1) PlotPoint(i,buffer2,buffer3,buffer1);
         if (trends[r][_trend] == 1) PlotPoint(i,buffer5,buffer6,buffer4);
      }
      else
      {
         if (trends[r][_slope1] == 1) PlotPoint(i,buffer2,buffer3,buffer1);
         if (trends[r][_slope2] == 1) PlotPoint(i,buffer5,buffer6,buffer4);
      }
   }      
   manageAlerts();
   
   //
   //
   //
   //
   //
   
   return(0);   
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      int whichBar=Bars-1;
      while (whichBar>0) { if (trends[whichBar][_trend] != trends[whichBar-1][_trend]) break; whichBar--; }
      if (trends[whichBar][_trend] != trends[whichBar-1][_trend])
      {
         if (trends[whichBar][_trend] ==  1) doAlert(whichBar,"above");
         if (trends[whichBar][_trend] == -1) doAlert(whichBar,"bellow");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS),"fast is ",doWhat," slow filter");
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Henderson filter crosses"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void ClearPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}